package tetris.d3d;

import java.util.ArrayList;

public class Model {
	public ArrayList<Vertex> vertices = new ArrayList<Vertex>();
	public ArrayList<Triangle> triangles = new ArrayList<Triangle>();
	public double[] location = {0, 0, 0};//x, y, z location
	public double rotation = 0;//around z
	
	public Model(boolean test){
		test();
	}
	public Model(){
	}
	
	/** Adds a Vertex to the model's collection of vertices */
	public void addVertex(Vertex vert){
		vertices.add(vert);
	}
	
	/** Adds a Triangle to the model's collection of triangles */
	public void addTriangle(Triangle triangle){
		triangles.add(triangle);
	}
	
	public void test(){
		vertices.add(new Vertex(1.000000, 1.000000, -0.999999));
		vertices.add(new Vertex(1.000000, -1.000000, -1.000000));
		vertices.add(new Vertex(-1.000000, -1.000000, -1.000000));
		vertices.add(new Vertex(-1.000000, 1.000000, -1.000000));
		vertices.add(new Vertex(-1.000000, -1.000000, 1.000000));
		vertices.add(new Vertex(-1.000000, 1.000000, 1.000000));
		vertices.add(new Vertex(1.000000, -1.000000, 0.523271));
		vertices.add(new Vertex(0.945751, 1.106593, 0.991438));
		vertices.add(new Vertex(1.148466, 0.198427, 1.651862));
		vertices.add(new Vertex(0.883131, 0.322333, 2.099871));
		triangles.add(new Triangle(1-1, 2-1, 3-1));
		triangles.add(new Triangle(1-1, 3-1, 4-1));
		triangles.add(new Triangle(5-1, 6-1, 4-1));
		triangles.add(new Triangle(5-1, 4-1, 3-1));
		triangles.add(new Triangle(2-1, 1-1, 7-1));
		triangles.add(new Triangle(1-1, 8-1, 7-1));
		triangles.add(new Triangle(1-1, 4-1, 6-1));
		triangles.add(new Triangle(1-1, 6-1, 8-1));
		triangles.add(new Triangle(2-1, 7-1, 3-1));
		triangles.add(new Triangle(7-1, 5-1, 3-1));
	}
	
	@Override
	public String toString(){
		String s = "";
		for (int i = 0; i < vertices.size(); i++){
			s += vertices.get(i).toString() + "\n";
		}
		for (int i = 0; i < triangles.size(); i++){
			s += triangles.get(i).toString() + "\n";
		}
		return s;
	}
}
//v 1.000000 1.000000 -0.999999
//v 1.000000 -1.000000 -1.000000
//v -1.000000 -1.000000 -1.000000
//v -1.000000 1.000000 -1.000000
//v -1.000000 -1.000000 1.000000
//v -1.000000 1.000000 1.000000
//v 1.000000 -1.000000 0.523271
//v 0.945751 1.106593 0.991438
//v 1.148466 0.198427 1.651862
//v 0.883131 0.322333 2.099871
//f 1 2 3
//f 1 3 4
//f 5 6 4
//f 5 4 3
//f 2 1 7
//f 1 8 7
//f 1 4 6
//f 1 6 8
//f 2 7 3
//f 7 5 3
